package com.tincancamera.asm.beans;

//import java.lang.Comparable;
import java.util.Comparator;

public class BeanNameComparator implements Comparator {
    @Override public int compare (Object left, Object right) {
        Comparable leftValue = ((Bean)left).getName();
        Comparable rightValue = ((Bean)right).getName();

        if (leftValue == null) {
            if (rightValue == null) return 0;
            return 1;
        }
        if (rightValue == null) return -1;

        return leftValue.compareTo(rightValue);
    }

    char getCharacter () { return 0; }
    byte getByte () { return 0; }
    short getShort () { return 0; }
    int getInteger () { return 0; }
    long getLong () { return 0; }
    float getFloat () { return 0; }
    double getDouble () { return 0; }
    boolean getBoolean () { return false; }


    public int compareCharacter (BeanNameComparator left, BeanNameComparator right) {
        char leftValue = left.getCharacter();
        char rightValue = right.getCharacter();

        if (leftValue == rightValue) return 0;
        return (leftValue < rightValue) ? -1 : 1;
    }

    public int compareByte (BeanNameComparator left, BeanNameComparator right) {
        byte leftValue = left.getByte();
        byte rightValue = right.getByte();

        if (leftValue == rightValue) return 0;
        return (leftValue < rightValue) ? -1 : 1;
    }

    public int compareShort (BeanNameComparator left, BeanNameComparator right) {
        short leftValue = left.getShort();
        short rightValue = right.getShort();

        if (leftValue == rightValue) return 0;
        return (leftValue < rightValue) ? -1 : 1;
    }

    public int compareInteger (BeanNameComparator left, BeanNameComparator right) {
        int leftValue = left.getInteger();
        int rightValue = right.getInteger();

        if (leftValue == rightValue) return 0;
        return (leftValue < rightValue) ? -1 : 1;
    }

    public int compareLong (BeanNameComparator left, BeanNameComparator right) {
        long leftValue = left.getLong();
        long rightValue = right.getLong();

        if (leftValue == rightValue) return 0;
        return (leftValue < rightValue) ? -1 : 1;
    }

    public int compareFloat (BeanNameComparator left, BeanNameComparator right) {
        float leftValue = left.getFloat();
        float rightValue = right.getFloat();

        if (leftValue == rightValue) return 0;
        return (leftValue < rightValue) ? -1 : 1;
    }

    public int compareDouble (BeanNameComparator left, BeanNameComparator right) {
        double leftValue = left.getDouble();
        double rightValue = right.getDouble();

        if (leftValue == rightValue) return 0;
        return (leftValue < rightValue) ? -1 : 1;
    }

    public int compareBoolean (BeanNameComparator left, BeanNameComparator right) {
        boolean leftValue = left.getBoolean();
        boolean rightValue = right.getBoolean();

        if (leftValue == rightValue) return 0;
        return (leftValue == false) ? -1 : 1;
    }


}
